require 'active_support/core_ext/string'
require 'uri'
require 'net/http'
require 'rack'
require 'opal'
require 'parser'

# isomorfeus needs kwargs
Parser::Builders::Default.emit_kwargs = true

require 'unparser'
require 'method_source'
require 'securerandom'
require 'isomorfeus-speednode'

# use execjs speednode for sure, unless something else has been specified
unless ENV["EXECJS_RUNTIME"]
  ExecJS.runtime = ExecJS::Runtimes::Speednode
end

require 'isomorfeus/puppetmaster'
require 'isomorfeus/puppetmaster/self_forwardable'
require 'isomorfeus/puppetmaster/errors'
require 'isomorfeus/puppetmaster/cookie'
require 'isomorfeus/puppetmaster/console_message'
require 'isomorfeus/puppetmaster/request'
require 'isomorfeus/puppetmaster/response'
require 'isomorfeus/puppetmaster/node'
require 'isomorfeus/puppetmaster/node/content_editable'
require 'isomorfeus/puppetmaster/node/input'
require 'isomorfeus/puppetmaster/node/checkbox'
require 'isomorfeus/puppetmaster/node/filechooser'
require 'isomorfeus/puppetmaster/node/radiobutton'
require 'isomorfeus/puppetmaster/node/select'
require 'isomorfeus/puppetmaster/node/textarea'
require 'isomorfeus/puppetmaster/document'
require 'isomorfeus/puppetmaster/iframe'
require 'isomorfeus/puppetmaster/driver/puppeteer_document'
require 'isomorfeus/puppetmaster/driver/puppeteer_node'
require 'isomorfeus/puppetmaster/driver/puppeteer'
require 'isomorfeus/puppetmaster/driver_registration'
require 'isomorfeus/puppetmaster/server/executor_middleware'
require 'isomorfeus/puppetmaster/server/middleware'
require 'isomorfeus/puppetmaster/server/checker'
require 'isomorfeus/puppetmaster/server'
require 'isomorfeus/puppetmaster/server_registration'

Isomorfeus::Puppetmaster.driver = :chromium
Isomorfeus::Puppetmaster.server = :iodine

require 'isomorfeus/puppetmaster/dsl'

Isomorfeus.node_paths << File.expand_path(File.join(File.dirname(__FILE__), '..', 'node_modules'))
